/****************************************************************************

     Modul:      timeleft.c, c-kllkod fr klocka/minne

     Version:    0.117

     Tid:        940524, 950607, 19h

    ---------------------------------------------------------------------
     940524:     Brjade skriva p denna koden. (MA)
    ---------------------------------------------------------------------
     940525:     Mycket mera kom till. (MA,10h)
    ---------------------------------------------------------------------
     940526:     Lite frflyttningar av koden. (MA,1h)
    ---------------------------------------------------------------------
     940613:     Lade till Dos16MemAvail. (MA,1h)
    ---------------------------------------------------------------------
     950314:     Fixade fr freewareversion. (MA,1h)
    ---------------------------------------------------------------------
     950529:     Bytte ut ikonen. (MA,1h)
    ---------------------------------------------------------------------
     950607:     Lade till FS_NOBYTEALIGN och CS_SYNCPAINT. (MA,1h)
    ---------------------------------------------------------------------
****************************************************************************/
#define INCL_DOS
#define INCL_WIN
#define INCL_GPI

#include <os2.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "timeleft.h"
#include "dialog.h"

MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY AboutDlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
void SizeWindow (HWND hwnd, int iFlag);
void UpdateWindow (HWND hwnd, HPS hps);
void InitMenu (HWND hwndMenu);
void LoadSettings (void);
void SaveSettings (void);
void MenuEnableItem (HWND hwndMenu, USHORT usMenuId, BOOL bEnabled);
void MenuCheckItem (HWND hwndMenu, USHORT usMenuId, BOOL bCheck);
void SetExeDirectory (void);
int DateSerial(char *szDate);
char *DateToday(int iFlag);
int MonthLen(int iYear, int iMonth);

/* -------------------------------------------------------------------- */

HAB             hab;
SETTINGS        prfSet;

/* -------------------------------------- */
#define isleap(year) ((((year%4)==0) && ((year%100)!=0)) || ((year%400)==0))


/* -------------------------------------- */
int             aiMonthLen[13];



/*-----------------------------------------------------------------------------
   main: Entrypoint into this program.                               940524
-----------------------------------------------------------------------------*/
int main (int argc, char *argv[])
     {
     static CHAR szClassName [] = "TimeLeft 0.115";
     HWND        hwndFrame,hwndClient;
     HMQ         hmq;
     QMSG        qmsg;

     ULONG       flFrameFlags=FCF_BORDER | FCF_TASKLIST | FCF_NOBYTEALIGN;


     hab = WinInitialize(0);
     hmq = WinCreateMsgQueue(hab, 0);

     WinRegisterClass(hab,szClassName, (PFNWP) ClientWndProc,
                      CS_SIZEREDRAW | CS_SYNCPAINT, 0);

     hwndFrame = WinCreateStdWindow (HWND_DESKTOP,
                                     0L,
                                     (PVOID)&flFrameFlags,
                                     szClassName,
                                     "",
                                     WS_VISIBLE,
                                     0L,
                                     0L,
                                     (PHWND) &hwndClient) ;

     SizeWindow (hwndClient, ID_FIRSTTIME);

     while (WinGetMsg (hab, &qmsg, (ULONG) NULL, 0L, 0L))
           WinDispatchMsg (hab, &qmsg) ;

     WinDestroyWindow (hwndFrame) ;
     WinDestroyMsgQueue (hmq) ;
     WinTerminate (hab);
     return(0);
     }

/*-----------------------------------------------------------------------------
   ClientWndProc: Handles messages for the client window.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     static HWND        hwndMenu;
     static BOOL        bDrag;
     static int         iMouseX, iMouseY;

     HWND               hwndFrame;
     HPS                hps;
     POINTL             ptl;
     SWP                swp;
     ULONG              flOptions;
     RECTL              rcl;

     ULONG              ulAttrFound, ulColorValue;
     char               szBuffer[64+1];


     switch (msg)
          {

          case WM_CREATE:
               SetExeDirectory();
               LoadSettings();
               WinStartTimer(hab, hwnd, ID_TIMER, 1000);
               hwndMenu = WinLoadMenu(hwnd, NULLHANDLE, ID_RESOURCE);
               InitMenu (hwndMenu);
               bDrag = FALSE;
               break;

          case WM_BEGINDRAG:
               WinQueryPointerPos(HWND_DESKTOP, &ptl);
               WinMapWindowPoints(HWND_DESKTOP, hwnd, &ptl, 1);
               iMouseX = ptl.x;
               iMouseY = ptl.y;
               bDrag = TRUE;
               break;

          case WM_MOUSEMOVE:
               if (bDrag == TRUE)
                  return WinSendMsg(WinQueryWindow(hwnd, QW_PARENT), WM_TRACKFRAME, MPFROMSHORT(TF_MOVE), NULL);
               break;

          case WM_ENDDRAG:
               if (bDrag == TRUE)
                  {
                  WinQueryPointerPos(HWND_DESKTOP, &ptl);
                  prfSet.ptl.x = ptl.x - iMouseX;
                  prfSet.ptl.y = ptl.y - iMouseY;
                  bDrag = FALSE;
                  }
               break;

          case WM_CONTEXTMENU:
               WinQueryPointerPos(HWND_DESKTOP, &ptl);
               WinMapWindowPoints(HWND_DESKTOP, hwnd, &ptl, 1);
               flOptions = PU_KEYBOARD | PU_MOUSEBUTTON1 | PU_HCONSTRAIN | PU_VCONSTRAIN;
               WinPopupMenu(hwnd, hwnd, hwndMenu, ptl.x, ptl.y,
                            0, (USHORT) flOptions);
               break;

          case WM_TIMER:
               if (prfSet.bStayOnTop == TRUE)
                  WinSetWindowPos(WinQueryWindow(hwnd,QW_PARENT), HWND_TOP, 0L, 0L,
                                  0L, 0L, SWP_ZORDER);
               WinInvalidateRect(hwnd, NULL, FALSE);
               break;

          case WM_COMMAND:
               switch (SHORT1FROMMP(mp1))
                      {
                      case IDM_DATETIMEMEMORY:
                           if (prfSet.iDisplay != ID_DATETIMEMEMORY)
                              {
                              prfSet.iDisplay = ID_DATETIMEMEMORY;
                              MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, TRUE);
                              MenuCheckItem(hwndMenu, IDM_DATETIME, FALSE);
                              MenuCheckItem(hwndMenu, IDM_TIMEONLY, FALSE);
                              SizeWindow(hwnd, ID_JUSTSIZE);
                              }
                           break;

                      case IDM_DATETIME:
                           if (prfSet.iDisplay != ID_DATETIME)
                              {
                              prfSet.iDisplay = ID_DATETIME;
                              MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, FALSE);
                              MenuCheckItem(hwndMenu, IDM_DATETIME, TRUE);
                              MenuCheckItem(hwndMenu, IDM_TIMEONLY, FALSE);
                              SizeWindow(hwnd, ID_JUSTSIZE);
                              }
                           break;

                      case IDM_TIMEONLY:
                           if (prfSet.iDisplay != ID_TIMEONLY)
                              {
                              prfSet.iDisplay = ID_TIMEONLY;
                              MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, FALSE);
                              MenuCheckItem(hwndMenu, IDM_DATETIME, FALSE);
                              MenuCheckItem(hwndMenu, IDM_TIMEONLY, TRUE);
                              SizeWindow(hwnd, ID_JUSTSIZE);
                              }
                           break;

                      case IDM_STAYONTOP:
                           if (prfSet.bStayOnTop == TRUE)
                              {
                              prfSet.bStayOnTop = FALSE;
                              MenuCheckItem(hwndMenu, IDM_STAYONTOP, FALSE);
                              }
                           else
                              {
                              prfSet.bStayOnTop = TRUE;
                              MenuCheckItem(hwndMenu, IDM_STAYONTOP, TRUE);
                              }
                           break;

                      case IDM_USUK:
                           prfSet.iChristmasDate = prfSet.iDay = 25;
                           MenuCheckItem(hwndMenu, IDM_SWEDEN, FALSE);
                           MenuCheckItem(hwndMenu, IDM_USUK, TRUE);
                           break;

                      case IDM_SWEDEN:
                           prfSet.iChristmasDate = prfSet.iDay = 24;
                           MenuCheckItem(hwndMenu, IDM_USUK, FALSE);
                           MenuCheckItem(hwndMenu, IDM_SWEDEN, TRUE);
                           break;

                      case IDM_ABOUT:
                           WinDlgBox(HWND_DESKTOP, hwnd, (PFNWP) AboutDlgProc, 0, DLG_ABOUT, 0);

                           break;

                      case IDM_EXIT:
                           WinPostMsg(hwnd, WM_QUIT, 0L, 0L);
                           break;

                      default:
                           return WinDefWindowProc(hwnd, msg, mp1, mp2);
                      }
               break;

          case WM_SAVEAPPLICATION:
               SaveSettings();
               break;

          case WM_PAINT:
               hps = WinBeginPaint(hwnd, 0L, 0L);
               WinQueryWindowRect(hwnd, &rcl);
               WinFillRect(hps, &rcl, GpiQueryColorIndex(hps, 0L, prfSet.iBackColor));
               UpdateWindow (hwnd, hps);
               WinEndPaint(hps);
               break ;

          case WM_PRESPARAMCHANGED:
               switch (LONGFROMMP(mp1))
                      {
                      case PP_FONTNAMESIZE:
                           WinQueryPresParam(hwnd, PP_FONTNAMESIZE, 0, &ulAttrFound,
                                             sizeof(szBuffer), (PVOID) &szBuffer, 0L);
                           if (PP_FONTNAMESIZE == ulAttrFound)
                              {
                              strcpy(prfSet.szFontSize, szBuffer);
                              SizeWindow(hwnd, ID_JUSTSIZE);
                              }
                           break;

                      case PP_FOREGROUNDCOLOR:
                           WinQueryPresParam(hwnd, PP_FOREGROUNDCOLOR, 0, &ulAttrFound,
                                             sizeof(ulColorValue), (PVOID) &ulColorValue, 0L);
                           if (PP_FOREGROUNDCOLOR == ulAttrFound)
                              prfSet.iForeColor = ulColorValue;
                           break;

                      case PP_BACKGROUNDCOLOR:
                           WinQueryPresParam(hwnd, PP_BACKGROUNDCOLOR, 0, &ulAttrFound,
                                             sizeof(ulColorValue), (PVOID) &ulColorValue, 0L);
                           if (PP_BACKGROUNDCOLOR == ulAttrFound)
                              prfSet.iBackColor = ulColorValue;
                           break;

                      default:
                           return WinDefWindowProc (hwnd, msg, mp1, mp2);

                      }
               return FALSE;

          case WM_CLOSE:
          case WM_QUIT:
               WinStopTimer(hab, hwnd, ID_TIMER);
               SaveSettings();
               return WinDefWindowProc(hwnd, msg, mp1, mp2);

          default:
               return WinDefWindowProc(hwnd, msg, mp1, mp2);
          }
     return FALSE;
     }


/*-----------------------------------------------------------------------------
   SizeWindow: Sizes window using current font.
-----------------------------------------------------------------------------*/
void SizeWindow (HWND hwnd, int iFlag)
     {
     HWND               hwndFrame;
     FONTMETRICS        fm;
     HPS                hps;
     RECTL              rcl;
     int                xWidth, yHeight;

     hwndFrame = WinQueryWindow(hwnd, QW_PARENT);

     if (iFlag == ID_FIRSTTIME)
        {
        WinSetPresParam(hwnd, PP_FONTNAMESIZE, (ULONG)sizeof(prfSet.szFontSize), (PVOID)&prfSet.szFontSize);
        }

     hps = WinGetPS(hwnd);
     GpiQueryFontMetrics(hps, (LONG) sizeof fm, &fm);
     WinReleasePS(hps);

     switch (prfSet.iDisplay)
            {
            case ID_DATETIMEMEMORY:
                 xWidth = 10;
                 yHeight = 4;
                 break;

            case ID_DATETIME:
                 xWidth = 8;
                 yHeight = 2;
                 break;

            case ID_TIMEONLY:
                 xWidth = 10;
                 yHeight = 2;
                break;
            }

     rcl.yBottom = prfSet.ptl.y;
     rcl.yTop    = rcl.yBottom + (yHeight * fm.lMaxBaselineExt);
     rcl.xLeft   = prfSet.ptl.x;
     rcl.xRight  = rcl.xLeft + (xWidth * fm.lEmInc);

     WinCalcFrameRect(hwndFrame, &rcl, FALSE);

     WinSetWindowPos(hwndFrame, NULLHANDLE, rcl.xLeft, rcl.yBottom,
                     (rcl.xRight - rcl.xLeft), (rcl.yTop - rcl.yBottom),
                     SWP_SIZE | SWP_MOVE | SWP_SHOW);

     }


/*-----------------------------------------------------------------------------
   UpdateWindow: Updates window with date/time/mem.
-----------------------------------------------------------------------------*/
void UpdateWindow (HWND hwnd, HPS hps)
     {
     static BOOL        bGotCountryInfo;
     static char        *szDayName[] = {"Sun", "Mon", "Tue", "Wen", "Thu", "Fri", "Sat"};
     static COUNTRYCODE ctryc = { 0, 850 };
     static COUNTRYINFO ctryi;

     char               szDateBuffer[40];
     char               szTimeBuffer[40];
     char               szMemBuffer[40];
     char               szBuffer[40];
     int                iTodayDay, iAlarmDay, iNowSeconds, iAlarmSecond;
     int                iDays, iHours, iMinutes, iSeconds;
     DATETIME           dt;
     ULONG              ulDataLength;
     ULONG              ulIndexForeColor, ulIndexBackColor;

     int                yTop;
     RECTL              rcl;


     if (!bGotCountryInfo)
        {
        DosQueryCtryInfo(sizeof(ctryi), &ctryc, &ctryi, &ulDataLength);
        bGotCountryInfo = TRUE;
        }

     DosGetDateTime(&dt);
     dt.year %= 100;

     switch (ctryi.fsDateFmt)
            {
            case 0:
                 sprintf(szDateBuffer, " %s %d%s%02d%s%02d ", szDayName[dt.weekday], dt.month, ctryi.szDateSeparator,
                         dt.day, ctryi.szDateSeparator, dt.year);
                 break;

            case 1:
                 sprintf(szDateBuffer, " %s %d%s%02d%s%02d ", szDayName[dt.weekday], dt.day, ctryi.szDateSeparator,
                         dt.month, ctryi.szDateSeparator, dt.year);
                 break;

            default:
                 sprintf(szDateBuffer, " %s %d%s%02d%s%02d ", szDayName[dt.weekday], dt.year, ctryi.szDateSeparator,
                         dt.month, ctryi.szDateSeparator, dt.day);
                 break;
            }


     if ((ctryi.fsTimeFmt & 1) == 0)
        {
        sprintf(szTimeBuffer, " %02d%s%02d%s%02d %cm ", (dt.hours + 11) % 12 + 1, ctryi.szTimeSeparator,
                dt.minutes, ctryi.szTimeSeparator, dt.seconds, dt.hours / 12 ? 'p' : 'a');
        }
     else
        {
        sprintf(szTimeBuffer, " %02d%s%02d%s%02d ", dt.hours, ctryi.szTimeSeparator,
                dt.minutes, ctryi.szTimeSeparator, dt.seconds);
        }


     sprintf(szBuffer, "%02d%02d%02d", prfSet.iYear-1900, prfSet.iMonth, prfSet.iDay);

     iTodayDay = DateSerial(DateToday(0));
     iAlarmDay = DateSerial(szBuffer);

     iAlarmSecond = prfSet.iSecond + (60 * prfSet.iMinute) + (60 * (60 * prfSet.iHour));
     iNowSeconds = dt.seconds + (60 * dt.minutes) + (60 * (60 * dt.hours));


     if (iTodayDay > iAlarmDay || (iTodayDay == iAlarmDay && iNowSeconds > iAlarmSecond) )
        {
        strcpy(szMemBuffer, "Has passed!");
        }
     else
        {
        iDays = iAlarmDay - iTodayDay;

        iSeconds = iAlarmSecond - iNowSeconds;
        if (iSeconds <= 0)
           {
           iDays--;
           iSeconds = ((60 * 60) * 24) - (-iSeconds);
           }

        iHours = iSeconds / (60 * 60);
        iSeconds = iSeconds % (60 * 60);
        iMinutes = iSeconds / 60;
        iSeconds = iSeconds % 60;

        if ((ctryi.fsTimeFmt & 1) == 0)
           {
           sprintf(szMemBuffer, " %d d, %d%s%02d%s%02d %cm ", iDays, (iHours + 11) % 12 + 1, ctryi.szTimeSeparator,
                   iMinutes, ctryi.szTimeSeparator, iSeconds, iHours / 12 ? 'p' : 'a');
           }
        else
           {
           sprintf(szMemBuffer, " %d d, %02d%s%02d%s%02d ", iDays, iHours, ctryi.szTimeSeparator,
                   iMinutes, ctryi.szTimeSeparator, iSeconds);
           }
        }
     ulIndexForeColor = GpiQueryColorIndex(hps, 0L, prfSet.iForeColor);
     ulIndexBackColor = GpiQueryColorIndex(hps, 0L, prfSet.iBackColor);

     switch (prfSet.iDisplay)
            {
            case ID_DATETIMEMEMORY:
                 WinQueryWindowRect(hwnd, &rcl);
                 yTop        = ((rcl.yTop - rcl.yBottom) / 4);
                 rcl.yBottom = yTop * 3;
                 WinDrawText(hps, -1, szDateBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_CENTER | DT_VCENTER);

                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yTop    = yTop * 3;
                 rcl.yBottom = yTop * 2;
                 WinDrawText(hps, -1, szTimeBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_CENTER | DT_VCENTER);

                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yTop    = yTop * 2;
                 rcl.yBottom = yTop;
                 WinDrawText(hps, -1, prfSet.szMsg, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_CENTER | DT_VCENTER);

                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yTop    =  yTop;
                 WinDrawText(hps, -1, szMemBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_CENTER | DT_VCENTER);

                 break;


            case ID_DATETIME:
                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yBottom += (5 * rcl.yTop) / 11;
                 WinDrawText(hps, -1, szDateBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_CENTER | DT_VCENTER);

                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yBottom -= (5 * rcl.yTop) / 11;
                 WinDrawText(hps, -1, szTimeBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_CENTER | DT_VCENTER);
                 break;

            case ID_TIMEONLY:
                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yBottom += (5 * rcl.yTop) / 11;
                 WinDrawText(hps, -1, prfSet.szMsg, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_CENTER | DT_VCENTER);

                 WinQueryWindowRect(hwnd, &rcl);
                 rcl.yBottom -= (5 * rcl.yTop) / 11;
                 WinDrawText(hps, -1, szMemBuffer, &rcl, ulIndexForeColor, ulIndexBackColor,
                             DT_CENTER | DT_VCENTER);
                break;
            }
     }


/*-----------------------------------------------------------------------------
   InitMenu: Sets menu at startup.
-----------------------------------------------------------------------------*/
void InitMenu (HWND hwndMenu)
     {

     switch (prfSet.iDisplay)
            {
            case ID_DATETIMEMEMORY:
                 MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, TRUE);
                 MenuCheckItem(hwndMenu, IDM_DATETIME, FALSE);
                 MenuCheckItem(hwndMenu, IDM_TIMEONLY, FALSE);
                 break;

            case ID_DATETIME:
                 MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, FALSE);
                 MenuCheckItem(hwndMenu, IDM_DATETIME, TRUE);
                 MenuCheckItem(hwndMenu, IDM_TIMEONLY, FALSE);
                 break;

            case ID_TIMEONLY:
                 MenuCheckItem(hwndMenu, IDM_DATETIMEMEMORY, FALSE);
                 MenuCheckItem(hwndMenu, IDM_DATETIME, FALSE);
                 MenuCheckItem(hwndMenu, IDM_TIMEONLY, TRUE);
                break;
            }

            MenuCheckItem(hwndMenu, IDM_STAYONTOP, prfSet.bStayOnTop);

            MenuCheckItem(hwndMenu, IDM_USUK, FALSE);
            MenuCheckItem(hwndMenu, IDM_SWEDEN, FALSE);

            if (prfSet.iChristmasDate == 25)
               MenuCheckItem(hwndMenu, IDM_USUK, TRUE);
            else
               MenuCheckItem(hwndMenu, IDM_SWEDEN, TRUE);
     }


/*-----------------------------------------------------------------------------
   LoadSettings: Loads settings from the user profile.
-----------------------------------------------------------------------------*/
void LoadSettings (void)
     {
     ULONG              pulBufferMax;
     HINI               hIni;

     hIni = PrfOpenProfile(hab, "TIMELEFT.INI");

     pulBufferMax = sizeof(prfSet);
     if (PrfQueryProfileData(hIni, "TimeLeft", "Settings", (PVOID) &prfSet, &pulBufferMax) != TRUE)
        {
        prfSet.ptl.x = 0;
        prfSet.ptl.y = 0;
        prfSet.iDisplay = 2;
        prfSet.bStayOnTop = FALSE;
        prfSet.iChristmasDate = 25;
        prfSet.iYear = 1997;
        prfSet.iMonth = 12;
        prfSet.iDay = 24;
        prfSet.iHour = 0;
        prfSet.iMinute = 0;
        prfSet.iSecond = 0;
        strcpy(prfSet.szMsg, "Until christmas");
        strcpy(prfSet.szFontSize, "10.Helv");
        prfSet.iForeColor = RGB_WHITE;
        prfSet.iBackColor = RGB_RED;
        PrfWriteProfileData(hIni, "TimeLeft", "Settings", (PVOID) &prfSet, sizeof(prfSet));
        }
     PrfCloseProfile(hIni);
     prfSet.iDay = prfSet.iChristmasDate;
     }


/*-----------------------------------------------------------------------------
   SaveSettings: Saves settings to the user profile.
-----------------------------------------------------------------------------*/
void SaveSettings (void)
     {
     HINI               hIni;

     hIni = PrfOpenProfile(hab, "TIMELEFT.INI");
     PrfWriteProfileData(hIni, "TimeLeft", "Settings", (PVOID) &prfSet, sizeof(prfSet));
     PrfCloseProfile(hIni);
     }


/*------------------------------------------------------------------------------
   AboutDlgProc: Handles messages for the DLG_ABOUT dialog.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY AboutDlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     HWND               hwndAnimate;
     RECTL              rclClient;
     char               szBuffer[256];

     switch (msg)
            {
            case WM_INITDLG:
                 hwndAnimate = WinWindowFromID(hwnd, DID_ABOUTLINE1);
                 WinQueryWindowRect(hwndAnimate, &rclClient);

                 WinSetDlgItemText(hwnd, DID_ABOUTLINE1, "");

                 WinSetDlgItemText(hwnd, DID_ABOUTLINE2, "TimeLeft 0.118 - 97/12/21");

                 WinSetDlgItemText(hwnd, DID_ABOUTLINE3, "Free christmas edition!");

                 WinSetDlgItemText(hwnd, DID_ABOUTLINE4, "Software Technologies (http://www.jmast.se)");


                 return (0);

            case WM_COMMAND:
                 switch (SHORT1FROMMP(mp1))
                        {
                        case DID_OK:
                             WinDismissDlg(hwnd, TRUE);
                             break;
                        }
                 break;
            default:
                 return (WinDefDlgProc (hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/****************************************************************************
  MenuEnableItem: Enable or disable menuitem.
****************************************************************************/
void MenuEnableItem (HWND hwndMenu, USHORT usMenuId, BOOL bEnabled)
     {
     USHORT             usFlag;

     if (!bEnabled)
        usFlag = MIA_DISABLED;
     else
        usFlag = TRUE;

     WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(usMenuId, TRUE), MPFROM2SHORT(MIA_DISABLED, usFlag));
     }


/****************************************************************************
  MenuCheckItem: Check or uncheck menuitem.
****************************************************************************/
void MenuCheckItem (HWND hwndMenu, USHORT usMenuId, BOOL bCheck)
     {
     USHORT             usFlag;

     if (bCheck)
        usFlag = MIA_CHECKED;
     else
        usFlag = TRUE;
     WinSendMsg(hwndMenu, MM_SETITEMATTR, MPFROM2SHORT(usMenuId, TRUE), MPFROM2SHORT(MIA_CHECKED, usFlag));
     }

/*-----------------------------------------------------------------------------
   SetExeDirectory: Sets the .EXE directory as current directory.
-----------------------------------------------------------------------------*/
void SetExeDirectory (void)
     {
     auto APIRET        rc;
     auto PTIB          pTib;
     auto PPIB          pPib;
     static char        szBuffer[128];

     short              sCounter;

     DosGetInfoBlocks(&pTib, &pPib);
     rc = DosQueryModuleName(pPib->pib_hmte, sizeof(szBuffer), szBuffer);

     if (szBuffer[1] == ':')
        DosSetDefaultDisk((ULONG)(toupper(szBuffer[0]) - 'A' + 1));

     sCounter = strlen(szBuffer);

     while ((szBuffer[sCounter] != '\\') && (sCounter > 0))
           sCounter--;

     if (sCounter > 0)
        {
        if (szBuffer[1] == ':' && sCounter == 2)
           {
           szBuffer[sCounter + 1] = '\0';
           DosSetCurrentDir(szBuffer);
           }
        else
           {
           szBuffer[sCounter] = '\0';
           DosSetCurrentDir(szBuffer);
           }
        }
     }

/*-----------------------------------------------------------------------------
  DateSerial: Converts datestring to serial number.
-----------------------------------------------------------------------------*/
int DateSerial(char *szDate)
     {
     char               szTmpDate[10];

     time_t             ltime;
     struct tm          *curtime;

     int                iYear, iMonth, iDay;
     int                iCounter;
     int                iDays;

     if (strlen(szDate) == 0)
        {
        time(&ltime);
        curtime = localtime(&ltime);
        sprintf(szTmpDate, "%.2d%.2d%.2d", curtime->tm_year, curtime->tm_mon+1, curtime->tm_mday);
        }
     else
        strcpy(szTmpDate, szDate);

     sscanf(szTmpDate, "%2d%2d%2d", &iYear, &iMonth, &iDay);

     iDays = 0;
     for (iCounter = 1;iCounter < (iYear - 79); iCounter++)
         {
         if (isleap(1979 + iCounter))
            iDays = iDays + 366;
         else
            iDays = iDays + 365;
         }

     MonthLen(1980 + iYear, 1);

     for (iCounter = 1;iCounter < iMonth; iCounter++)
         {
         iDays = iDays + aiMonthLen[iCounter];
         }

     return (iDays + iDay);

     }


/*-----------------------------------------------------------------------------
  DateToday: Returns a string with todays date.
-----------------------------------------------------------------------------*/
char *DateToday(int iFlag)
     {
     static char        szBuffer[16];
     time_t             ltime;
     struct tm          *curtime;

     time(&ltime);
     curtime = localtime(&ltime);

     switch (iFlag)
            {
            case 0:
                 sprintf(szBuffer, "%.2d%.2d%.2d", curtime->tm_year, curtime->tm_mon+1, curtime->tm_mday);
                 break;
            
            case 1:
                 sprintf(szBuffer, "(%.2d%.2d%.2d/%.2d:%.2d)", curtime->tm_year, curtime->tm_mon+1, curtime->tm_mday, curtime->tm_hour, curtime->tm_min);
                 break;

            case 2:
                 sprintf(szBuffer, "19%.2d%.2d%.2d", curtime->tm_year, curtime->tm_mon+1, curtime->tm_mday);
                 break;
            
            case 3:
                 sprintf(szBuffer, "(19%.2d%.2d%.2d/%.2d:%.2d)", curtime->tm_year, curtime->tm_mon+1, curtime->tm_mday, curtime->tm_hour, curtime->tm_min);
                 break;
                 }

     return(szBuffer);
     }


/*-----------------------------------------------------------------------------
  MonthLen: Return correct lenght of specified year's months.
-----------------------------------------------------------------------------*/
int MonthLen(int iYear, int iMonth)
     {
     int                iCounter;

     for (iCounter = 1; iCounter <= 12; iCounter++)
         aiMonthLen[iCounter] = 31;

     aiMonthLen[2] = 28;
     aiMonthLen[4] = 30;
     aiMonthLen[6] = 30;
     aiMonthLen[9] = 30;
     aiMonthLen[11] = 30;

     if (isleap(iYear))
        aiMonthLen[2] = 29;

     return (aiMonthLen[iMonth]);
     }
